CON

        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000


OBJ
  term  : "FullDuplexSerial"
  f       : "FloatMath"

{{
PUB start | integer,s,x,m,t,sa1,sa2,a 
  term.start( 31, 30, 0, 57_600 )
  waitcnt(clkfreq*3 + cnt)
  term.tx(0)
  term.str(string("Float Demo...",13))

  sa1 := f.FFloat(8)
  term.str(string("sa1="))
  term.hex(sa1,8)
   term.tx(13)
  
'  sa2 := f.FFloat(536870912)
  sa2 := f.FFloat(53)
  term.str(string("sa2="))
  term.hex(sa2,8)
   term.tx(13)
  a := f.FMul(sa1,sa2)
  term.hex(a,8)
   term.tx(13)
  a := f.FRound(a)
  term.hex(a,8) 
   term.tx(13)
  term.dec(a)
}}


PUB start | integer,s,x,m,t,sa1,sa2,a,t1,t2
  ' start up the floating point objects and my serial link
  term.start( 31, 30, 0, 57_600 )
  waitcnt(clkfreq*3 + cnt)
  term.tx(0)
  term.str(string("Float Demo...",13))

  integer := 16078
  term.hex(integer,8)
   term.tx(13)
  term.tx(13)
  if m := ||integer             'absolutize mantissa, if 0, result 0
    s := integer >> 31          'get sign
    x := >|m - 1                'get exponent
    m <<= 31 - x                'msb-justify mantissa
    m >>= 2                     'bit29-justify mantissa

  term.dec(s)
  term.tx(13)
  term.dec(x)
  term.tx(13)
   term.hex(m,8)
  term.tx(13)         
'    term.str(string("ggggg"))
  term.tx(13)  
  t := f.FFloat(integer)
'  t := FFloat(integer)
  term.hex(t,8)

  term.tx(13) 
  term.dec(f.fround(t))
  term.tx(13)
  term.tx(13)
  t := f.FFloat(2009.75)
  term.hex(t,8)
  term.tx(13) 
  term.hex(f.fround(t),8)

  term.tx(13) 

  term.str(string("test"))
  t := f.FFloat(0.75) 
  t1 := f.FFloat(0.25)
  t2 := f.FAdd(t,t1)
  term.hex(t2,8)
  term.tx(13) 
  term.dec(f.FRound(t2))



  
{{
      term.str(string("dddd")) 
  sa1 := FFloat(8)
  sa2 := FFloat(536870912)
  a := FMul(sa1,sa2)
  term.hex(a,8) 
}}
PUB FFloat(integer) : single | s, x, m

''Convert integer to float    

  if m := ||integer             'absolutize mantissa, if 0, result 0
    s := integer >> 31          'get sign
    x := >|m - 1                'get exponent
    m <<= 31 - x                'msb-justify mantissa
    m >>= 2                     'bit29-justify mantissa

    return Pack(@s)             'pack result


PRI Pack(pointer) : single | s, x, m

'Pack floating-point from (sign, exponent, mantissa) at pointer

  longmove(@s, pointer, 3)      'get (s,x,m) structure into locals

  if m                          'if mantissa 0, result 0
  
    result := 33 - >|m          'determine magnitude of mantissa
'             term.dec(result)
'             term.tx(13)
    m <<= result                'msb-justify mantissa without leading 1
    term.dec(m)
    term.tx(13) 
    x += 3 - result             'adjust exponent
'             term.dec(x)
'             term.tx(13)

    m += $00000100              'round up mantissa by 1/2 lsb
    if not m & $FFFFFF00        'if rounding overflow,
      x++                       '..increment exponent
'  term.dec(x)
'             term.tx(13)
'
    
    x := x + 127 #> -23 <# 255  'bias and limit exponent

    if x < 1                    'if exponent < 1,
      m := $8000_0000 +  m >> 1 '..replace leading 1
      m >>= -x                  '..shift mantissa down by exponent
      x~                        '..exponent is now 0

    return s << 31 | x << 23 | m >> 9 'pack result


PUB FMul(singleA, singleB) : single | sa, xa, ma, sb, xb, mb

''Multiply singleA by singleB

  Unpack(@sa, singleA)          'unpack inputs
  Unpack(@sb, singleB)

  sa ^= sb                      'xor signs
  xa += xb                      'add exponents
  ma := (ma ** mb) << 3         'multiply mantissas and justify
  term.str(string("fmul"))
  term.tx(13)
  term.hex(ma,8)
  term.tx(13)
  return Pack(@sa)              'pack result

PRI Unpack(pointer, single) | s, x, m

'Unpack floating-point into (sign, exponent, mantissa) at pointer

  s := single >> 31             'unpack sign
  x := single << 1 >> 24        'unpack exponent
  m := single & $007F_FFFF      'unpack mantissa

  if x                          'if exponent > 0,
    m := m << 6 | $2000_0000    '..bit29-justify mantissa with leading 1
  else
    result := >|m - 23          'else, determine first 1 in mantissa
    x := result                 '..adjust exponent
    m <<= 7 - result            '..bit29-justify mantissa

  x -= 127                      'unbias exponent

  longmove(pointer, @s, 3)      'write (s,x,m) structure from locals
  