fl

{
character-LCD demo codes
This demo operate on each H/W.

Operating HardWare
2_wire_LCD_counter(8bit)
   
    PropForth 5.2 
    18/09/2012 14:04:32

}

hex

: set_bar_graph
20 40
6 0 do                                  \ set 6 charcters
     8 0 do                             \ set 8 lines for 1 character
          dup lcd_com                   \ command for character to CG-RAM
          swap dup lcd_char swap        \ write data
          1+    
     loop
     F8 and   
     swap dup 1 rshift or swap
loop
2drop
;

: demo1
lcd_init
 10 4 lcd_setup                         \ 16characters 4line

\ display char-code [0x20 - 0x7f] & [0xa0 - 0xff]
20
line W@ 2 = if 7 0 else 3 0 then
do
     line W@ 2 = 
     if 
          i 3 = 
          if 
               4 seti drop A0 
          then 
          2 0 
     else 
          4 0 
     then
     do line W@ 4 = 
          if j 1 = 
               if i 2 = 
                    if 20 + 
          thens 
          1 i 1+ lcd_pos 10 0 do dup lcd_char 100 delms  1+ loop                                                         
     loop                                           
loop  
drop

lcd_clr                                              
\ display binary, hex, decimal
c" 0x1+0x6 = b" lcd_str 1 6 + 4 lcd_bin

1 2 lcd_pos       
c" 0xACE+0xF=0x" lcd_str ACE F + 4 lcd_hex
5 0 do 3E8 delms loop

lcd_clr  1 cur_line W!                               
c" 0x12+0xe0=" lcd_str
12 E0 + lcd_dec_L c" (D)" lcd_str
lcd_cr

c" 0x0-0x12=" lcd_str
0 12 - lcd_dec_L c" (D)" lcd_str
5 0 do 3E8 delms loop

lcd_clr 1 cur_line W!
-3E9 lcd_dec_L
lcd_cr
-3E9 lcd_dec_R
3 0 do 3E8 delms loop
hex

set_bar_graph
lcd_clr  1 cur_line W!                                            
c" Bar Graph" lcd_str 
1    \ x-position 
char W@ 0
do 
     0 
     6 0 do 
          dup lcd_char        \ print bar_graph character
           1+ 64 delms  
           swap dup 2 lcd_pos swap      \ set same x-position                 
     loop 
     drop
     1+ dup 2 lcd_pos         \ increment x-position 
loop
drop

char W@ 2 lcd_pos
char W@
char W@ 0
do
     5
     6 0 do 
          dup lcd_char        \ print bar_graph character 
          1- 64 delms  
          swap dup 2 lcd_pos swap       \ set same x-positionap 
     loop 
     drop
     1- dup 2 lcd_pos         \ decrement x-position
loop
drop

lcd_clr                                                        
c" Demo Finished" lcd_str
1 2 lcd_pos
B3 C4 DE B6 D8 B1 20 C6 B7 B5 B5 B 0 do lcd_char loop
;

: set_bar_graph2
40
8 0 do              \ set 8 charcters
      8 0 do        \ set 8 lines for 1 character
            dup lcd_com     \ command for character to CG-RAM 
            7 j - i <
            if 1F else 0 then lcd_char     \ write data
            1+ 
          loop
          F8 and
    loop
drop
;
         
variable tmp1
: demo2   \ wave
cnt COG@
lcd_init

 10 4 lcd_setup      \ 16characters 4line
set_bar_graph2
lcd_clr                                                        
c" Wave" lcd_str
1 2 lcd_pos                                                    
1 tmp L! 1 tmp1 L!
0
100 0 do
     dup char W@ 0 
     do dup lcd_char dup 7 = tmp L@ 1 = and 
            if drop FF
            else dup FF = if drop 7 -1 tmp L!    
                          else dup 0 = if 1+ 1 tmp L!
                                       else tmp L@ + 
            thens
     loop
     drop
     1 2 lcd_pos                                             
     dup 7 = tmp1 L@ 1 = and 
               if drop FF
               else dup FF = if drop 7 -1 tmp1 L!
                             else dup 0 = if 1+ 1 tmp1 L!
                                          else tmp1 L@ +
               thens
loop
drop 
1 3 lcd_pos                                                 
cnt COG@ swap -    
13880 u/ lcd_dec_L c" msec" lcd_str                     
; 




\ This demo use 16characters X 4line LCD.
wvariable X
wvariable Y
wvariable sign
wvariable y_limit

: demo3
cnt COG@
lcd_init

 10 4 lcd_setup      \ 16characters 4line
set_bar_graph2
lcd_clr 
char W@ X W!
line W@ Y W!                                                       
1 sign W!
Y W@ 8 u* y_limit W!

1 0            \ ( cnt Y_incremrnt[X=1] Y_value -- )   at X-pos top
100 0 do            
     2dup          \ ( Y_incremrnt Y_value -- )
     \ character -out to X-direction
     X W@ 0 do           \ i
          dup 9 <
          if
               dup i 1+ Y W@ lcd_pos dup 8 = if drop FF then lcd_char 
               i 1+ Y W@ 1- lcd_pos 0 lcd_char    
          else               \ ( Y_incremrnt Y_value -- )
               dup 8 u/mod                    
                    \ quotient           ( Y_incremrnt Y_value remainder quotient -- )
               i swap >r 1+ Y W@ r> 0 do 2dup lcd_pos FF lcd_char 1- loop nip      
                    \ remainder          ( Y_incremrnt Y_value remainder Y-pos --)
               over 0<>
               if
                    i 1+ swap lcd_pos lcd_char
               else
                    dup 0>
                    if
                         i 1+ swap lcd_pos 0 lcd_char drop
                    else
                         2drop
                    then
               then
                    
          then         
          \ ( Y_incremrnt Y_value --)    
          2dup 
          + dup y_limit W@ >  if   \ check if more than 0x20
                                   drop nip -1 swap
                              else   \ check if less than 0
                                   0< if nip 1 swap then
                              then
          over + 
          \ delay 
          j 12 < if 64 delms then          
     loop     
     2drop     
     \ ( cnt Y_incremrnt[X=1] Y_value -- )
     \ return X-pos to top
     2dup + dup y_limit W@ >  if   \ check if more than 0x20
                                   drop nip -1 swap
                              else   \ check if less than 0
                                   0< if nip 1 swap  then
                              then
     over +     
loop
3drop
;


\ Using normal and BigFont 
wvariable str_buffer 1E allot
wvariable ptr
\ wvariable lcd_ptr 
wvariable size
: demo4
lcd_init
str_buffer ptr W!
\ char W@ lcd_ptr W!
lcd_clr
c" May the Forth be with you." 

\ set string to str_bufer
C@++ dup 
if 
     bounds do 
               i C@ 
               ptr W@ C! ptr W@ 1+ ptr W!
     loop 
else 2drop 
then

\ shift-out string from right to left
ptr W@ str_buffer - 1- size W!

\ set LCD_start_position
str_buffer char W@ - 
size W@ 1+ char W@ + 0 do
     dup
     1 1 lcd_pos 
     char W@ 0 do
               dup i + dup str_buffer str_buffer size W@ + between
               \ print blank_char when out of str_buffer 
               if C@ else drop bl then lcd_char   
               A delms
     loop
     drop
     1+
     64 delms
loop 
drop          

\ Using BigFont
bf_set
set_char_segment
bf_clear

str_buffer bf_char W@ -
size W@ 1+ bf_char W@ + 0 do
     dup
     1 1 bf_pos
     bf_char W@ 0 do
          dup i + dup str_buffer str_buffer size W@ + between
          \ print blank_char when out of str_buffer
          if C@ else drop bl then set_big_font
          next_bigfont_pos 
          80 delms
     loop
     drop
     1+
     80 delms
loop 
drop          
            
;

\ Using BigFont 
: demo5
lcd_init
10 4 lcd_setup      \ 16characters 4line   
                    \ Defsult setting is 16Charcters & 2Lines 
bf_set
set_char_segment
bf_clear

20        \ first ascii code
B 0 do
     bf_line W@ 0 do
                    bf_char W@ 0 do                    
                                \   i 1+ j 1+ bf_pos
                         dup set_big_font next_bigfont_pos 1+
                         100 delms
                    loop
     loop       
loop
drop

bf_clear
c" ABCDEF" bf_str   
;
                                      
decimal
