fl

hex
{
DeltaRobot_main
PropForth5.2

12/10/2012 23:41:16
}

\ servo initial position[0degree]
d940 wconstant initial_sv1
d1000 wconstant initial_sv2
d970 wconstant initial_sv3

\ current and target for nunchaku
variable current_x 
variable current_y 
variable current_z 
variable target_x 
variable target_y
variable target_z

: deltarobot
\ Initialize uM-FPUv3.1 and set constants
init_FPU

\ Initialize servo motor and set initial position[0degree]
\ servo output pin:0,1,2
servo_init              

\ Initialize nunchaku
init_nunchuck            

0 0 current_x L! target_x L!
0 0 current_y L! target_y L!
d-150 d-150 current_z L! target_z L!

0 0 initial_sv1 setpos
0 1 initial_sv2 setpos
0 2 initial_sv3 setpos

cnt COG@ 500msec +                           
\ main loop
begin
     readNunchaku
     get_value
     sx L@ target_x L!
     sy L@ target_y L!        
     z W@ 0=
     if
          current_z L@ 
          az L@ dup 0< if abs 14 u/ negate -1 min else 14 u/ 1 max then     \ Set Z-accel/20
          -     
          dup d-220 <
          if 
               drop d-220 target_z L!
          else
               dup d-150 >
               if
                    drop d-150 target_z L!
               else
                    target_z L!
     thens
  
     \ Convert (x,y,z) to servo-motor pulse(usec)
     ." X=" target_x L@ . ." Y=" target_y L@ . ." Z=" target_z L@ . cr
     target_z L@ target_y L@ target_x L@ inv_kinematics
     wait_FPU                 
     calc_success? 2 =
     if
          successLED pinhi
          getAngle             
          \ servo motor3
          initial_sv3 + 0 2 rot setpos
          \ servo motor2
          initial_sv2 + 0 1 rot setpos
          \ servo motor1
          initial_sv1 + 0 0 rot setpos          
          target_x L@ current_x L! 
          target_y L@ current_y L!
          target_z L@ current_z L!
     else     
          successLED pinlo
          current_x L@ target_x L! 
          current_y L@ target_y L!
          current_z L@ target_z L!
              
     then
     500msec waitcnt                      
fkey? swap drop            
until
drop
0 cogreset
;


decimal
